Bug 431045

Summary: Anaconda installer fails to detect lpars
Product: [Fedora] Fedora Reporter: IBM Bug Proxy <bugproxy>
Component: halAssignee: David Zeuthen <davidz>
Status: CLOSED RAWHIDE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: urgent Docs Contact:
Priority: low    
Version: rawhideCC: dwmw2, jlaska, mclasen, notting, pertusus, pnasrat
Target Milestone: ---   
Target Release: ---   
Hardware: ppc64   
OS: All   
URL: ARRAY(0x8bcb70)
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2008-03-05 11:22:56 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 235706    
Attachments:
Description Flags
/proc/device-tree/
none
vio support for hal none

Description IBM Bug Proxy 2008-01-31 07:48:18 EST
=Comment: #0=================================================
Mohammed Omar <mohd.omar@in.ibm.com> - 2008-01-31 04:31 EDT
---Problem description:---

Installation of Rawhide(F9alpha) has not able to detect Hard disk which has been
lpared.The version of Anaconda is 11.4.0.28.

-----------------log ------
Welcome to Fedora for ppc
    ┌────────────────────────┤ Partitioning Type ├─────────────────────────┐    
    │                                                                      │    
    │    Installation requires partitioning of your hard drive.  The       │    
    │    default layout is reasonable for most users.  You can either      │    
    │    choose to use this or create your own.                            │    
    │                                                                      │    
    │ Remove all partitions on selected drives and create default layout   │    
    │ Remove Linux partitions on selected drives and create default layout │    
    │ Use free space on selected drives and create default layout          │    
    │ Create custom layout                                                 │    
    │                                                                      │    
    │      Which drive(s) do you want to use for this installation?        │    
    │                                 ↑                                    │    
    │                                 ▮                                    │    
    │                                                                      │    
    │                          ┌────┐   ┌──────┐                           │    
    │                          │ OK │   │ Back │                           │    
    │                          └────┘   └──────┘                           │    
    │                                                                      │    
    │                                                                      │    
    └──────────────────────────────────────────────────────────────────────┘    

<Space>,<+>,<-> selection   |   <F2> Add drive   |   <F12> next screen 


Welcome to Fedora for ppc
                                                                                
                                                                                
                                                                                
                                                                                
                 ┌────────────┤ No Drives Found ├─────────────┐                 
                 │                                            │                 
                 │ An error has occurred - no valid devices   │                 
                 │ were found on which to create new file     │                 
                 │ systems. Please check your hardware for    │                 
                 │ the cause of this problem.                 │                 
                 │                                            │                 
                 │                  ┌────┐                    │                 
                 │                  │ OK │                    │                 
                 │                  └────┘                    │                 
                 │                                            │                 
                 │                                            │                 
                 └────────────────────────────────────────────┘                 
                                                                                
                                                                                
                                                                                
                                                                                

  <Tab>/<Alt-Tab> between elements   |  <Space> selects   |  <F12> next screen 
  
  
  
---------Hardware Environment----------
    Machine type (p650, x235, SF2, etc.): P55, P550
    Cpu type (Power4, Power5, IA-64, etc.): Power5
    
--------Is this reproducible?-------
Yes

-----Describe the steps:----
step 1: Boot any lpared Power5(p55,p550) box with "ppc64.img"
step 2: Proceed with installation until reaches "partitioning page"


-------Additional information:------------

NOTE: Hard disk has been detected in P520 (non-lpared) machine and installation
was succesfull.
Comment 1 IBM Bug Proxy 2008-01-31 07:56:21 EST
------- Comment From skannery@in.ibm.com 2008-01-31 07:56 EDT-------
Redhat team,
The system is having pre-installed OS. Will a SOS/SystemReport be of any
additional help here.. pls let us know.
Thanks, Supriya
Comment 2 David Woodhouse 2008-01-31 08:20:48 EST
What manner of disk / controller does this machine have? 
Comment 3 Paul Nasrat 2008-01-31 08:33:54 EST
Working with reporter via irc to establish more information
Comment 4 IBM Bug Proxy 2008-01-31 09:25:24 EST
Created attachment 293582 [details]
/proc/device-tree/
Comment 5 Bill Nottingham 2008-01-31 11:51:58 EST
From a quick look at the OF tree, this box uses ibmvscsic as a controller.

ibmvscsic does not export any aliases that would cause it to get automatically
loaded by udev. For any driver that needs to be loaded, it needs to export these
alisaes so it can be loaded by the normal udev mechanisms on a boot-time scan of
/sys.

You may want to look at the of_device_id and MODULE_DEVICE_TABLE support in
things like the bmac driver or the ohci_hcd PPC openfirmware support for examples.

Essentially, this is a kernel bug.
Comment 6 David Woodhouse 2008-01-31 15:45:33 EST
Hm, the driver has this:
/**
 * ibmvscsi_device_table: Used by vio.c to match devices in the device tree we 
 * support.
 */
static struct vio_device_id ibmvscsi_device_table[] __devinitdata = {
        {"vscsi", "IBM,v-scsi"},
        { "", "" }
};
MODULE_DEVICE_TABLE(vio, ibmvscsi_device_table);

Doesn't look like we even get a modules.viomap from the kernel build though.
Will investigate.
Comment 7 Bill Nottingham 2008-01-31 15:52:33 EST
Well, it would need to be in modules.alias, not modules.viomap. And also hooked
up somewhere as a modalias that udev would catch in sysfs.

Is there a reason it would use vio instead of of?
Comment 8 David Woodhouse 2008-01-31 16:43:43 EST
(In reply to comment #7)
> Well, it would need to be in modules.alias, not modules.viomap. And also hooked
> up somewhere as a modalias that udev would catch in sysfs.

The former is OK; I'll check up on the latter.

> Is there a reason it would use vio instead of of?

I think it's because it also exists on iSeries too where there isn't a
device-tree (or at least there wasn't before).
Comment 9 James Laska 2008-02-06 11:03:09 EST
omar: As a workaround, are you able to boot the F9 alpha installer with the
command-line option "noprobe" and manually specify the ibmvscsic and ibmveth
drivers?
Comment 10 James Laska 2008-02-06 18:43:36 EST
Reproduced internally on power5 lpar.

Booting with the "noprobe" cmdline option, I can manually select the ibmvscsic
and ibmveth modules

        +---------------+ Select Device Driver to Load +---------------+
        |                                                              |
        | Please select the driver below which you wish to load.  If   |
        | it does not appear and you have a driver disk, press F2.     |        
        |                                                              |        
        |   IBM Power RAID SCSI Adapter Driver (ipr)              ^    |        
        |   IBM ServeRAID Adapter Driver 7.12.05 (ips)            #    |        
        |   IBM Virtual SCSI (ibmvscsic)                          :    |        
        |   IBM Virtual SCSI Target (ibmvstgt)                    :    |        
        |   IBM eServer HEA Driver (ehea)                         :    |        
        |   IBM i/pSeries Virtual Ethernet Driver (ibmveth)       v    |        
        |                                                              |        
        |            [ ] Specify optional module arguments             |        
        |                                                              |        
        |            +----+                       +------+             |        
        |            | OK |                       | Back |             |        
        |            +----+                       +------+             |
        |                                                              |
        |                                                              |
        +--------------------------------------------------------------+

After adding ibmvscsic, then ibmveth, I am prompted as follows:

               +------------------+ Devices +------------------+                
               |                                               |                
               | No device drivers have been loaded for your   |                
               | system.  Would you like to load any now?      |                
               |                                               |                
               |                                               |                
               |      +------+            +------------+       |                
               |      | Done |            | Add Device |       |                
               |      +------+            +------------+       |                
               |                                               |                
               |                                               |                
               +-----------------------------------------------+                

Sending syslog to another system ... I'm not seeing anything obvious

Feb  6 18:17:03 ibm-hv2-lp6 INFO    Starting message bus...
Feb  6 18:17:08 ibm-hv2-lp6 INFO    Starting HAL daemon...
Feb  6 18:17:13 ibm-hv2-lp6 INFO    anaconda called with cmdline =
['/usr/bin/anaconda', '-m',
'http://porkchop.redhat.com/released/F-9/Alpha/Fedora/ppc/os', '--syslog',
'test118.test.redhat.com', '--noipv6', '-T', '--selinux', '--kickstart',
'/tmp/ks.cfg', '--virtpconsole', '/dev/hvc0', '--lang', 'en_US', '--loglevel',
'debug']
Feb  6 18:17:13 ibm-hv2-lp6 INFO    Display mode = t
Feb  6 18:17:13 ibm-hv2-lp6 INFO    Method =
http://porkchop.redhat.com/released/F-9/Alpha/Fedora/ppc/os
Feb  6 18:17:13 ibm-hv2-lp6 INFO    No video hardware found, assuming headless
Feb  6 18:17:17 ibm-hv2-lp6 WARNING Graphical installation not available... 
Starting text mode.
Feb  6 18:17:19 ibm-hv2-lp6 ERROR   error scanning mpaths, disabling: (2, 'No
such file or directory')
Feb  6 18:17:19 ibm-hv2-lp6 WARNING step installtype does not exist
Feb  6 18:17:19 ibm-hv2-lp6 WARNING step confirminstall does not exist
Feb  6 18:17:19 ibm-hv2-lp6 WARNING step complete does not exist
Feb  6 18:17:19 ibm-hv2-lp6 WARNINGlast message repeated 4 times
Feb  6 18:17:19 ibm-hv2-lp6 INFO    moving (1) to step networkdevicecheck
Feb  6 18:17:19 ibm-hv2-lp6 INFO    moving (1) to step partitionobjinit
Feb  6 18:17:19 ibm-hv2-lp6 INFO    no initiator set
Feb  6 18:17:19 ibm-hv2-lp6 INFO    no /tmp/fcpconfig; not configuring zfcp
Feb  6 18:17:20 ibm-hv2-lp6 INFO    moving (1) to step parttype
Comment 11 Bill Nottingham 2008-02-06 20:18:59 EST
So, *that* would almost certainly be the storage/net devices not showing up in
HAL. That may be a separate bug.
Comment 12 IBM Bug Proxy 2008-02-06 21:08:39 EST
------- Comment From jwboyer@us.ibm.com 2008-02-06 21:02 EDT-------
(In reply to comment #16)
> ------- Comment From notting@redhat.com 2008-02-06 20:18 EST-------
> So, *that* would almost certainly be the storage/net devices not showing up in
> HAL. That may be a separate bug.

Actually, Jesse has hit something like that on the PS3 as well.  I don't have
all the details, but when we looked at the kernel the PS3 storage drivers had
the right modalias foo in them and it seemed hald was just not finding the disks
for some reason.

Both LPARs and the PS3 access disk through a hypervisor, so perhaps there is
something wonky there.
Comment 13 IBM Bug Proxy 2008-02-07 00:57:08 EST
------- Comment From mohd.omar@in.ibm.com 2008-02-07 00:54 EDT-------
Hi james,

I found some thing strange here, when ppc64.img booted up with "noprobe". I
couldn't find "ibmvscscic"   but ibmveth was listed.

-----------------------+ Select Device Driver to Load +-------------------------
Please select the driver below which you wish to load.  If
it does not appear and you have a driver disk, press F2.
usion MPT LAN driver (mptlan)
L620-USB-A Host-to-Host Link cables (gl620a)
elic Network driver (ps3_gelic)
BM eServer HEA Driver (ehea)
BM i/pSeries Virtual Ethernet Driver (ibmveth)
P-over-InfiniBand net driver (ib_ipoib)
[ ] Specify optional module arguments
+----+                                  +------+
| OK |                                  | Back |
+----+                                  +------+
--------------------------------------------------------------------------------

And once I select ibmveth it gives some .......

+----+                                  +------+
| *** glibc detected *** /sbin/loader: double free or corruption
(!prev): 0x103e69a8 ***
+----+                                  +------+
======= Backtrace: =========
[0x10194c2c]
[0x10198e0c]
--------------------------------------------------------------------------------
[0x1002aa8c]
[0x10027790]<Alt-Tab> between elements  | <Space> selects | <F12> next
screen
[0x10011ad4]
[0x100043c4]
[0x1015e31c]
[0x1015e4bc]
======= Memory map: ========
00100000-00103000 r-xp 00100000 00:00 0                                  [vdso]


10000000-10294000 r-xp 00000000 00:01 54
/sbin/loader

102a3000-102b2000 rw-p 00293000 00:01 54
/sbin/loader


102b2000-1041c000 rwxp 102b2000 00:00 0                                  [heap]

f7ffc000-f7fff000 rw-p f7ffc000 00:00 0

ffcd8000-ffced000 rw-p ffffffeb000 00:00 0

-------------------------------------------------------------------------------

--Regards
Omar
Comment 14 James Laska 2008-02-07 09:10:41 EST
omar: please confirm the tree you are testing with when hitting the above error
(cat .discinfo or .treeinfo ... or .buildstamp inside the initrd)?  Is this a
fedora tree, or a custom spin?
Comment 15 IBM Bug Proxy 2008-02-07 09:56:36 EST
------- Comment From mohd.omar@in.ibm.com 2008-02-07 09:53 EDT-------
James,
I didn't use initrd+vmlinuz for installation. I used netboot image "ppc64.img"
of F9Alpha release when hitting the above error!!

--Regards
Omar
Comment 16 IBM Bug Proxy 2008-02-18 06:56:59 EST
------- Comment From skannery@in.ibm.com 2008-02-18 06:54 EDT-------
Redhat Team,
Pls give your inputs..
Thanks, Supriya
Comment 17 Bill Nottingham 2008-02-18 15:17:57 EST
The comments still apply: the modules need to export the proper aliases to be
automatically loaded, and upstream HAL needs support for any block devices they
create.
Comment 18 IBM Bug Proxy 2008-02-29 00:08:37 EST
------- Comment From skannery@in.ibm.com 2008-02-29 00:06 EDT-------
Redhat Team,
Any updates here..
Thanks, Supriya
Comment 19 David Woodhouse 2008-03-05 04:40:22 EST
I believe the proper aliases are present. Where is the HAL bug corresponding to
this?
Comment 20 David Woodhouse 2008-03-05 06:14:01 EST
When I run udevtrigger I see events like this...

UDEV  [1204715425.339542] add      /devices/vio/30000003 (vio)
UDEV_LOG=3
ACTION=add
DEVPATH=/devices/vio/30000003
SUBSYSTEM=vio
SEQNUM=785
PHYSDEVBUS=vio
PHYSDEVDRIVER=ibmvscsi
MODALIAS=vio:TvscsiSIBM,v-scsi
UDEVD_EVENT=1
DRIVER=ibmvscsi


However, the devices in /sys/bus/vio/ don't have a 'modalias' attribute. Does
that matter?
Comment 21 David Woodhouse 2008-03-05 09:52:24 EST
Created attachment 296882 [details]
vio support for hal

This adds support to HAL for vio devices. Should that be enough to make the
install happy?

udi = '/org/freedesktop/Hal/devices/vio_30000003'
  info.bus = 'vio'  (string)
  info.linux.driver = 'ibmvscsi'  (string)
  info.parent = '/org/freedesktop/Hal/devices/vio_vio'	(string)
  info.product = 'Vio Device (30000003)'  (string)
  info.subsystem = 'vio'  (string)
  info.udi = '/org/freedesktop/Hal/devices/vio_30000003'  (string)
  linux.hotplug_type = 2  (0x2)  (int)
  linux.subsystem = 'vio'  (string)
  linux.sysfs_path = '/sys/devices/vio/30000003'  (string)
  vio.id = '30000003'  (string)
Comment 22 David Zeuthen 2008-03-05 11:22:56 EST
Thanks, committed upstream and packages are building for Rawhide.
Comment 23 David Woodhouse 2008-03-05 18:58:19 EST
With (my build of) the new HAL, and with a kernel which puts modalias attributes
into sysfs for vio devices, the installer detects both ibmveth and ibmvscsic
devices correctly. I get as far as...

Welcome to Fedora for ppc64
                                                                                
                                                                                
            ┌────────────────┤ System to Upgrade ├─────────────────┐            
            │                                                      │            
            │ There seem to be one or more existing Linux          │            
            │ installations on your system.                        │            
            │                                                      │            
            │ Please choose one to upgrade, or select 'Reinstall   │            
            │ System' to freshly install your system.              │            
            │                                                      │            
            │         Reinstall System                             │            
            │         Fedora 8 (/dev/VolGroup00/LogVol00)          │            
            │                                                      │            
            │          ┌────┐                   ┌──────┐           │            
            │          │ OK │                   │ Back │           │            
            │          └────┘                   └──────┘           │            
            │                                                      │            
            │                                                      │            
            └──────────────────────────────────────────────────────┘            
                                                                                
                                                                                

  <Tab>/<Alt-Tab> between elements   |  <Space> selects   |  <F12> next screen

Comment 24 IBM Bug Proxy 2008-03-13 18:24:44 EDT
------- Comment From skannery@in.ibm.com 2008-03-13 18:16 EDT-------
Omar,
> ------- Comment From davidz@redhat.com 2008-03-05 11:22 EST-------
> Thanks, committed upstream and packages are building for Rawhide.
Pls check if the Rawhide is available for testing. If yes, pls verify
whether this issue is resolved.
Thanks, Supriya
Comment 25 IBM Bug Proxy 2008-03-19 10:48:43 EDT
------- Comment From mohd.omar@in.ibm.com 2008-03-19 10:40 EDT-------
Supriya,
There is a blocker for F9-Beta(rawhide) #43218.
Comment 26 IBM Bug Proxy 2008-03-25 02:08:45 EDT
------- Comment From mohd.omar@in.ibm.com 2008-03-25 02:03 EDT-------
F9-Beta detects LPARs of Power machines.
-----------
Welcome to Fedora for ppc
┌────────────────────────┤ Partitioning Type ├─────────────────────────┐
│                                                                      │
│    Installation requires partitioning of your hard drive.  The       │
│    default layout is reasonable for most users.  You can either      │
│    choose to use this or create your own.                            │
│                                                                      │
│ Remove all partitions on selected drives and create default layout   │
│ Remove Linux partitions on selected drives and create default layout │
│ Use free space on selected drives and create default layout          │
│ Create custom layout                                                 │
│                                                                      │
│      Which drive(s) do you want to use for this installation?        │
│                [*]    sda    66558 MB (AIX VDASD) ↑                  │
│                                                   ▮                  │
│                                                                      │
│                          ┌────┐   ┌──────┐                           │
│                          │ OK │   │ Back │                           │
│                          └────┘   └──────┘                           │
│                                                                      │
│                                                                      │
└──────────────────────────────────────────────────────────────────────┘

<Space>,<+>,<-> selection   |   <F2> Add drive   |   <F12> next screen